/* //////////////////////////////////////////////////////////////////////////////

		Dclaration de l'interface et de l'implmentation d'une Pile gnrique

   ////////////////////////////////////////////////////////////////////////////// */


/* ////////////////////////////////////////////////////////////
				Dfintion de l'interface Pile
   //////////////////////////////////////////////////////////// */
#define INTERFACE_PILE(TYPE)							\
														\
typedef struct { TYPE *pile, *top; } Pile_##TYPE;		\
														\
void CreerPile_##TYPE(Pile_##TYPE *, int) ;				\
														\
void DetruirePile_##TYPE(Pile_##TYPE *p);				\
														\
void EmpilerPile_##TYPE(Pile_##TYPE *, TYPE);			\
														\
TYPE DepilerPile_##TYPE(Pile_##TYPE *);


/* ////////////////////////////////////////////////////////////
		   Dfintion de l'implmentation de Pile
   //////////////////////////////////////////////////////////// */
#define IMPLEMENTATION_PILE(TYPE)						\
														\
void CreerPile_##TYPE(Pile_##TYPE *p, int dim)			\
{														\
	p->pile = p->top = (TYPE *) malloc(dim * sizeof(TYPE));		\
}														\
														\
void DetruirePile_##TYPE(Pile_##TYPE *p)				\
{														\
	free(p->pile);										\
}														\
														\
void EmpilerPile_##TYPE(Pile_##TYPE *p, TYPE x)			\
{														\
	*p->top++ = x;										\
}														\
														\
TYPE DepilerPile_##TYPE(Pile_##TYPE *p)					\
{														\
	return *--p->top;									\
}

